// ADIN_protocol.cpp : R\[ AvP[Vp̃Gg |Cg̒`
//

#include "stdafx.h"
#include "com_adin.h"

void disp_sts( int sts, char *buf, FILE *fp );

#define N_adin   "tmp_adin.bin"   //WAiAv̏o̓t@C
#define N_ctl    "I2C_ctl.txt"    //I2CfR[heLXgt@C
#define N_bin    "I2C_data.bin"   //I2CROMt@C


#define b_scl 0x01
#define b_sda 0x02

//STS
#define F_OFF    0
#define F_START  1
#define F_STOP   2
#define F_ACK    3
#define F_ADR    4
#define F_DAT    5
#define F_DISP   10    //DISP

#define D_WR     0
#define D_RD     1
#define UP       5

int BINOUT = OFF;     //ROM ON=LAOFF=

int main(int argc, char* argv[])
{
    int c;

    FILE *fo, *fb;
    long flen;
    char ww1[100],ww2[100];

    if( BINOUT )
    {
      printf("===============================================\n");
      printf("  I2C-ROM                                  \n");
      printf("  {ɑΉ                               \n");
      printf("  foCXɂẮAΉ̂߂ɉKv   \n");
      printf("===============================================\n");
      printf("  Enter key ");
      getch();
    }



    //t@CI[v
    if( (fo = fopen( N_adin, "rb+" ))==NULL)
    {
      printf("̓t@CRDł܂");
      getch();
      return(0);
    }

    flen = filelength( fileno(fo) );     //t@C length
    fseek( fo, 0, SEEK_SET );


    //Imہiʏ̔zmۂłȂj
    WORD *buf = new WORD[flen];         //SްAWORDȂ̂2{mۂĂ

    //t@Cf[^
    if(fread( buf, flen, 1, fo ) != 1)
    {
      printf("̓t@CRDł܂");
      fclose(fo);
      getch();
      return(0);
    }

    fclose(fo);

    //ϊt@C
    if( (fo = fopen( N_ctl, "w+" ))==NULL)
    {
      printf("t@C쐬ł܂");
      getch();
      return(0);
    }

    if( (fb = fopen( N_bin, "wb+" ))==NULL)
    {
      printf("oCit@C쐬ł܂");
      getch();
      fclose(fo);
      return(0);
    }

    int sda, scl;
    int chg_sda = OFF;
    int chg_scl = OFF;
    int old_sda =  b_sda;
    int old_scl =  b_scl;
    int sts = F_OFF;
    int old_sts = OFF;
    int c_bit = 0;
    int dataw,rw,binw_f;

    for(c=0; c<(flen/2); c++)           // /2= WORDŊmۂ
    {
      //ωo SDA
      sda = buf[c] & b_sda;

      if( old_sda != sda )   //ω
        chg_sda = ON;
      else
        chg_sda = OFF;

      old_sda = sda;

      //ωo SCL
      scl = buf[c] & b_scl;

      if( ( scl != old_scl )&&( scl == b_scl ) )  //ω̂
        chg_scl = UP;
      else
        chg_scl = OFF;

      old_scl = scl;

      if( c == 0 )  //rJnłoldinit悤ɏ̂Ă
        continue;

      if( scl && ( chg_sda == ON ) && (!sda) )  //START
      {
        sts = F_START;
      }

      if( scl && ( chg_sda == ON ) && (sda) )  //STOP
      {
        sts = F_STOP;
      }

      switch ( sts )
      {
      case F_OFF:
        binw_f = OFF;
        break;

      case F_START:
        disp_sts( F_START, "\nSTART", fo );
        sts = F_ADR;
        c_bit = 0;
        dataw = 0;
        break;

      case F_STOP:
        disp_sts( F_STOP, "\nSTOP", fo );
        sts = F_OFF;
        break;

      case F_ADR:
        if( chg_scl == UP )
        {
          if( c_bit )   //擪ȊO
            dataw <<= 1;
          if( sda == b_sda )
            dataw |= 1;

          c_bit ++;
        }
        if( c_bit == 8 )
        {
          strcpy(ww1, "SlaveADR ");
          sprintf(ww2, "%02X ", dataw );
          strcat(ww1, ww2);

          if( (dataw & 0x01) ==  D_RD )  //RD or WR
          {
            rw = D_RD;
            strcpy(ww2, "RD");
            if( binw_f == 1 )
              binw_f = 2;
          }
          else
          {
            rw = D_WR;
            strcpy(ww2, "WR");
            binw_f = 1;
          }
          strcat(ww1, ww2);
          disp_sts( F_ADR, ww1, fo );

          sts = F_ACK;
          c_bit = 0;
          dataw = 0;
        }
        break;

      case F_ACK:
        if( chg_scl == UP )
        {
          sts = F_DAT;
          if( sda == b_sda )
            disp_sts( F_ACK, "NACK", fo );
          else
            disp_sts( F_ACK, "ACK", fo );
        }
        break;

      case F_DAT:
        //̃p[ǵAfoCXɂāAADR,DATA\sKɂȂBADR1,2sK
        //Ȃ̂ō׋敪͖Ȃ̂ł̂܂ܕ\AfoCX肷΂
        if( chg_scl == UP )
        {
          if( c_bit )   //擪ȊO
            dataw <<= 1;
          if( sda == b_sda )
            dataw |= 1;

          c_bit ++;
        }

        if( c_bit == 8 )
        {
          sprintf(ww1, "%02X", dataw );

          disp_sts( F_DAT, ww1, fo );
          if( ( binw_f == 2 )&&( BINOUT ) )
          {
            if(fwrite( &dataw, 1, 1, fb ) != 1)    // *1 = byte
            {
              printf("oCit@CCgł܂");
              getch();
              fclose(fo);
              fclose(fb);
              return(0);
            }
          }

          sts = F_ACK;
          c_bit = 0;
          dataw = 0;
        }
        break;


      default:
        break;
      }
    }

    fclose(fo);
    fclose(fb);

    delete buf;  //IJ

    getch();
    return 0;
}


//\
void disp_sts( int sts, char *buf, FILE *fp )
{
    static int old_sts = OFF;
    char ww[200];

    sprintf(ww, "%s\n", buf );

    if( sts == F_DISP )    //DISP
    {
      printf( ww );
      fputs( ww, fp );
      return;
    }

    if( sts != old_sts )
    {
      printf( ww );
      fputs( ww, fp );
    }


    old_sts = sts;
}

